/*
 * rockantenne.c: A plugin for the Video Disk Recorder
 *
 * See the README file for copyright information and how to reach the author.
 *
 * $Id$
 */

#include "rockantenne.h"
#include <vdr/interface.h>
#include <vdr/plugin.h>

#define TIMEOUT_SECS 2
/* very ugly, but very simple X-) */
#include "get_song_data.c"

static const char *VERSION        = "0.0.2";
static const char *DESCRIPTION    = "Show song played on Rockantenne";
static const char *MAINMENUENTRY  = "Rockantenne";

class cPluginRockantenne : public cPlugin {
private:
  // Add any member variables or functions you may need here.
  struct song_data song;
  char http_buf[BUFLEN+1];
public:
  cPluginRockantenne(void);
  virtual ~cPluginRockantenne();
  virtual const char *Version(void) { return VERSION; }
  virtual const char *Description(void) { return DESCRIPTION; }
  virtual const char *CommandLineHelp(void);
  virtual bool ProcessArgs(int argc, char *argv[]);
  virtual bool Initialize(void);
  virtual bool Start(void);
  virtual void Stop(void);
  virtual void Housekeeping(void);
  virtual void MainThreadHook(void);
  virtual cString Active(void);
  virtual const char *MainMenuEntry(void) { return MAINMENUENTRY; }
  virtual cOsdObject *MainMenuAction(void);
  virtual cMenuSetupPage *SetupMenu(void);
  virtual bool SetupParse(const char *Name, const char *Value);
  virtual bool Service(const char *Id, void *Data = NULL);
  virtual const char **SVDRPHelpPages(void);
  virtual cString SVDRPCommand(const char *Command, const char *Option, int &ReplyCode);
  };

cPluginRockantenne::cPluginRockantenne(void)
{
  // Initialize any member variables here.
  // DON'T DO ANYTHING ELSE THAT MAY HAVE SIDE EFFECTS, REQUIRE GLOBAL
  // VDR OBJECTS TO EXIST OR PRODUCE ANY OUTPUT!
}

cPluginRockantenne::~cPluginRockantenne()
{
  // Clean up after yourself!
}

const char *cPluginRockantenne::CommandLineHelp(void)
{
  // Return a string that describes all known command line options.
  return NULL;
}

bool cPluginRockantenne::ProcessArgs(int argc, char *argv[])
{
  // Implement command line argument processing here if applicable.
  return true;
}

bool cPluginRockantenne::Initialize(void)
{
  // Initialize any background activities the plugin shall perform.
  return true;
}

bool cPluginRockantenne::Start(void)
{
  // Start any background activities the plugin shall perform.
  return true;
}

void cPluginRockantenne::Stop(void)
{
  // Stop any background activities the plugin shall perform.
}

void cPluginRockantenne::Housekeeping(void)
{
  // Perform any cleanup or other regular tasks.
}

void cPluginRockantenne::MainThreadHook(void)
{
  // Perform actions in the context of the main program thread.
  // WARNING: Use with great care - see PLUGINS.html!
}

cString cPluginRockantenne::Active(void)
{
  // Return a message string if shutdown should be postponed
  return NULL;
}

cOsdObject *cPluginRockantenne::MainMenuAction(void)
{
  int i;
  char song_data[STRING_LEN+1];
  register char *p;

  // Perform the action when selected from the main VDR menu.
  i = do_http_get(http_buf, BUFLEN);
  if (i) {
    i = get_song_data(http_buf, i, &song);
    if (i!=0) {
      Skins.Message(mtStatus, "<error while parsing data>", Setup.OSDMessageTime);
    } else {
      p = song_data;
      i = str_copyn(p, song.interpret, STRING_LEN/2);
      p += i;
      i = str_copyn(p, song.title, STRING_LEN/2);
      p[i] = '\0';
      p = song_data;
      // limit string
      p[42] = '\0';
      Skins.Message(mtStatus, p, Setup.OSDMessageTime);
    }
  } else {
    Skins.Message(mtStatus, "<error on http-get>", Setup.OSDMessageTime);
  }
  return NULL;
}

cMenuSetupPage *cPluginRockantenne::SetupMenu(void)
{
  // Return a setup menu in case the plugin supports one.
  return NULL;
}

bool cPluginRockantenne::SetupParse(const char *Name, const char *Value)
{
  // Parse your own setup parameters and store their values.
  return false;
}

bool cPluginRockantenne::Service(const char *Id, void *Data)
{
  // Handle custom service requests from other plugins
  return false;
}

const char **cPluginRockantenne::SVDRPHelpPages(void)
{
  // Return help text for SVDRP commands this plugin implements
  return NULL;
}

cString cPluginRockantenne::SVDRPCommand(const char *Command, const char *Option, int &ReplyCode)
{
  // Process SVDRP commands this plugin implements
  return NULL;
}

VDRPLUGINCREATOR(cPluginRockantenne); // Don't touch this!
